package com.persagy.apm.diagnose.service;

import com.alibaba.fastjson.JSONObject;
import com.persagy.apm.diagnose.maintenance.constant.EnumAlarmCategory;
import com.persagy.apm.diagnose.maintenance.constant.EnumAlarmItem;
import com.persagy.apm.energyalarmstarter.alarmdata.feign.AlarmUrlParam;
import com.persagy.apm.energyalarmstarter.alarmengine.service.NettyAlarmService;
import com.sun.xml.internal.bind.v2.TODO;
import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.Arrays;
import java.util.List;

@Service
public class NettyAlarmServiceImpl extends NettyAlarmService {


    @Autowired
    private CenterDataService centerDataService;

    @Override
    public String getMeterId(String infoCode, String classCode) throws Exception {
        String separator = "_";
        if (!infoCode.contains(separator)) {
            throw new Exception("infoCode格式不正确，应包含'" + separator +
                    "'，classCode=" + classCode + "; infoCode=" + infoCode);
        }
        String[] tmp = infoCode.split(separator);
        return tmp[0];
    }

    @Override
    public String getFuncId(String infoCode, String classCode) throws Exception {
        String separator = "_";
        if (!infoCode.contains(separator)) {
            throw new Exception("infoCode格式不正确，应包含'" + separator +
                    "'，classCode=" + classCode + "; infoCode=" + infoCode);
        }
        int indexOf = infoCode.indexOf(separator);
        return infoCode.substring(indexOf + 1);
    }

    @Override
    public String getAlarmName(String projectId, String objId, String category) {
        return null;
    }

    @SneakyThrows
    @Override
    public JSONObject getAlarmSupplement(AlarmUrlParam alarmUrlParam, JSONObject alarmRecord) {
//        "supplement": {
//            "alarm_obj_name": "yy1中文名"
//        }

        String objId = alarmRecord.getString("objId");
        List<JSONObject> objectList = centerDataService.queryObjListByObjId(alarmRecord.getString("projectId"), Arrays.asList(objId));
        JSONObject supplement = new JSONObject();
        if (!CollectionUtils.isEmpty(objectList)) {
            JSONObject object = objectList.get(0);
            supplement.put("alarm_obj_name", object.get("localName"));
            //TODO 维保
            String category = alarmRecord.getString("category");
            if (EnumAlarmCategory.EQWB.equals(category)){//报警分类
//                supplement.put("classCode",object.getString("classCode"));//设备类型编码
                supplement.put("specification",object.getString("specification"));//设备型号
                supplement.put("equip_local_id",object.getString("localId"));//设备本地编码
                supplement.put("equip_local_name",object.getString("localName"));//设备本地名称
            }
        }
        return supplement;
    }

    @Override
    public String getAlarmRemark(AlarmUrlParam data, String objId, String itemCode) {

//        List<JSONObject> objectList = centerDataService.queryObjListByObjId(alarmRecord.getString("projectId"), Arrays.asList(objId));
//        JSONObject supplement = new JSONObject();
//        if (!CollectionUtils.isEmpty(objectList)) {
//            JSONObject object = objectList.get(0);
//        }

        //维保
        if (EnumAlarmItem.CondAbnormal.getCode().equals(itemCode)) {// 冷凝器异常
            return "检查冷凝器脏堵情况，并酌情进行清洗。";
        }else if (EnumAlarmItem.EvapAbnormal.getCode().equals(itemCode)){// 蒸发器异常
            return "检查蒸发器脏堵情况，并酌情进行清洗。";
        }else if (EnumAlarmItem.CoolTowerApproachTempAbnormal.getCode().equals(itemCode)){// 冷却塔逼近温度异常
            return "检查冷却水加药装置运行是否正常；检查冷却塔填料破损和脏堵情况，并酌情安排维护或清洗。";
        }
        return null;
    }

}
